/// Immutable data class for wallet.
///
/// Returned by `Capsule.createWallet`.
class Wallet {
  const Wallet._({
    required this.id,
    required this.signer,
    this.address,
    this.publicKey,
  });

  /// Unique identifier of the wallet.
  final String id;

  /// Signer in hex string format.
  final String signer;

  /// Address in hex string format.
  final String? address;

  /// Public key in hex string format.
  final String? publicKey;

  factory Wallet.from(Map<String, dynamic> params) {
    return Wallet._(
      id: params['id'] as String,
      signer: params['signer'] as String,
      address: params['address'] as String?,
      publicKey: params['publicKey'] as String?,
    );
  }
}
